



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Cocoa深入学习:NSOperationQueue、NSRunLoop和线程安全 (转)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Cocoa深入学习:NSOperationQueue、NSRunLoop和线程安全 (转)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 13:22:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>目前在 iOS 和 OS X 中有两套先进的同步 API 可供我们使用：NSOperation 和 GCD 。其中 GCD 是基于 C 的底层的 API ，而 NSOperation 则是 GCD 实现的 Objective-C API。 虽然 NSOperation 是基于 GCD 实现的， 但是并不意味着它是一个 GCD 的 &ldquo;dumbed-down&rdquo; 版本， 相反，我们可以用NSOperation 轻易的实现一些 GCD 要写大量代码的事情。 因此， NSOperationQueue 是被推荐使用的， 除非你遇到了 NSOperationQueue 不能实现的问题。</p>
<h2>1. 为什么优先使用NSOperationQueue而不是GCD</h2>
<p>曾经我有一段时间我非常喜欢使用GCD来进行并发编程，因为虽然它是C的api，但是使用起来却非常简单和方便, 不过这样也就容易使开发者忘记并发编程中的许多注意事项和陷阱。</p>
<p>比如你可能写过类似这样的代码(这样来请求网络数据)：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>dispatch_async(_Queue, ^{

  //请求数据<br />
  NSData *data = [NSData dataWithContentURL:[NSURL URLWithString:@"http://domain.com/a.png"]];

    dispatch_async(dispatch_get_main_queue(), ^{

         [self refreshViews:data];<br />
    });<br />
});<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>没错，它是可以正常的工作，但是有个致命的问题：<strong>这个任务是无法取消的</strong>&nbsp;<code>dataWithContentURL:</code>是同步的拉取数据，它会一直阻塞线程直到完成请求，如果是遇到了超时的情况，它在这个时间内会一直占有这个线程；在这个期间并发队列就需要为其他任务新建线程，这样可能导致性能下降等问题。</p>
<p>因此我们不推荐这种写法来从网络拉取数据。</p>
<p>操作队列（operation queue）是由 GCD 提供的一个队列模型的 Cocoa 抽象。GCD 提供了更加底层的控制，而操作队列则在 GCD 之上实现了一些方便的功能，这些功能对于 app 的开发者来说通常是最好最安全的选择。NSOperationQueue相对于GCD来说有以下优点：</p>
<ul><li>提供了在 GCD 中不那么容易复制的有用特性。</li>
<li>可以很方便的取消一个NSOperation的执行</li>
<li>可以更容易的添加任务的依赖关系</li>
<li>提供了任务的状态：isExecuteing, isFinished.</li></ul>
<p><strong>名词： 本文中提到的 &ldquo;任务&rdquo;， &ldquo;操作&rdquo; 即代表要再NSOperation中执行的事情。</strong></p>
<h2>2. Operation Queues的使用</h2>
<h3>2.1 NSOperationQueue</h3>
<p><code>NSOperationQueue</code>&nbsp;有两种不同类型的队列：主队列和自定义队列。主队列运行在主线程之上，而自定义队列在后台执行。在两种类型中，这些队列所处理的任务都使用&nbsp;<code>NSOperation</code>&nbsp;的子类来表述。</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>NSOperationQueue *mainQueue = [NSOperationQueue mainQueue];  //主队列<br />
NSOperationQueue *queue = [[NSOperationQueue alloc] init]; //自定义队列<br />
NSBlockOperation *operation = [NSBlockOperation blockOperationWithBlock:^{<br />
                //任务执行<br />
            }];<br />
[queue addOperation:operation];<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>我们可以通过设置&nbsp;<code>maxConcurrentOperationCount</code>&nbsp;属性来控制并发任务的数量，当设置为&nbsp;<code>1</code>&nbsp;时， 那么它就是一个串行队列。主对列默认是串行队列，这一点和&nbsp;<code>dispatch_queue_t</code>&nbsp;是相似的。</p>
<h3>2.2 NSOperation</h3>
<p>你可以使用系统提供的一些现成的&nbsp;<code>NSOperation</code>&nbsp;的子类， 如&nbsp;<code>NSBlockOperation</code>、<code>NSInvocationOperation</code>&nbsp;等（如上例子）。你也可以实现自己的子类， 通过重写&nbsp;<code>main</code>&nbsp;或者&nbsp;<code>start</code>方法 来定义自己的 operations 。</p>
<p>使用&nbsp;<code>main</code>&nbsp;方法非常简单，开发者不需要管理一些状态属性（例如 isExecuting 和 isFinished），当 main 方法返回的时候，这个 operation 就结束了。这种方式使用起来非常简单，但是灵活性相对重写 start 来说要少一些， 因为main方法执行完就认为operation结束了，所以一般可以用来执行同步任务。</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>@implementation YourOperation<br />
- (void)main<br />
{<br />
    // 任务代码 ...<br />
}<br />
@end<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>如果你希望拥有更多的控制权，或者想在一个操作中可以执行异步任务，那么就重写&nbsp;<code>start</code>&nbsp;方法, 但是注意：这种情况下，你必须手动管理操作的状态， 只有当发送&nbsp;<code>isFinished</code>&nbsp;的 KVO 消息时，才认为是 operation 结束</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
11<br />
12
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>@implementation YourOperation<br />
- (void)start<br />
{<br />
  self.isExecuting = YES;<br />
    // 任务代码 ...<br />
}<br />
- (void)finish //异步回调<br />
{<br />
  self.isExecuting = NO;<br />
  self.isFinished = YES;<br />
}<br />
@end<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>当实现了start方法时，默认会执行start方法，而不执行main方法</strong></p>
<p>为了让操作队列能够捕获到操作的改变，需要将状态的属性以配合&nbsp;<code>KVO</code>&nbsp;的方式进行实现。如果你不使用它们默认的 setter 来进行设置的话，你就需要在合适的时候发送合适的&nbsp;<code>KVO</code>&nbsp;消息。</p>
<p>需要手动管理的状态有：</p>
<ul><li><code>isExecuting</code>&nbsp;代表任务正在执行中</li>
<li><code>isFinished</code>&nbsp;代表任务已经执行完成</li>
<li><code>isCancelled</code>&nbsp;代表任务已经取消执行</li></ul>
<p>手动的发送&nbsp;<code>KVO</code>&nbsp;消息， 通知状态更改如下 ：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>[self willChangeValueForKey:@"isCancelled"];<br />
_isCancelled = YES;<br />
[self didChangeValueForKey:@"isCancelled"];<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>为了能使用操作队列所提供的取消功能，你需要在长时间操作中时不时地检查&nbsp;<code>isCancelled</code>&nbsp;属性, 比如在一个长的循环中:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>@implementation MyOperation

- (void)main<br />
{<br />
    while (notDone &amp;&amp; !self.isCancelled) {<br />
        // 任务处理<br />
    }<br />
}<br />
@end<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<h2>3. RunLoop</h2>
<p>在cocoa中讲到多线程，那么就不得不讲到RunLoop。 在ios/mac的编码中，我们似乎不需要过多关心代码是如何执行的，一切仿佛那么自然。比如我们知道当滑动手势时，tableView就会滚动，启动一个NSTimer之后，timer的方法就会定时执行， 但是为什么呢，其实是RunLoop在帮我们做这些事情：分发消息。</p>
<h3>3.1 什么是RunLoop</h3>
<p>你应该看过这样的伪代码解释ios的app中main函数做的事情：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>int main(int argc, char * argv[])<br />
{<br />
    while (true) {<br />
      [[NSRunLoop currentRunLoop] runMode:NSDefaultRunLoopMode beforeDate:[NSDate distantFuture]];<br />
    }<br />
}<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>也应该看过这样的代码用来阻塞一个线程：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>while (!complete) {<br />
    [[NSRunLoop currentRunLoop] runMode:NSDefaultRunLoopMode beforeDate:[NSDate distantFuture]];<br />
}<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>或许你感觉到他们有些神奇，希望我的解释能让你明白一些.</p>
<p>我们先思考一个问题： 当我们打开一个IOS应用之后，什么也不做，这时候看起来是没有代码在执行的，为什么应用没有退出呢？</p>
<p>我们在写c的简单的只有一个main函数的程序时就知道，当main的代码执行完，没有事情可做的时候，程序就执行完毕退出了。而我们IOS的应用是如何做到在没有事情做的时候维持应用的运行的呢? 那就是RunLoop。</p>
<p>RunLoop的字面意思就是&ldquo;运行回路&rdquo;，听起来像是一个循环。实际它就是一个循环，它在循环监听着事件源，把消息分发给线程来执行。RunLoop并不是线程，也不是并发机制，但是它在线程中的作用至关重要，它提供了一种异步执行代码的机制。</p>
<h3>3.2 事件源</h3>
<p><img referrerpolicy="no-referrer"src="https://blog.cnbluebox.com/images/NSRunLoop.gif" /></p>
<p>由图中可以看出NSRunLoop只处理两种源：输入源、时间源。而输入源又可以分为：<code>NSPort</code>、自定义源、<code>performSelector:OnThread:delay:</code>, 下面简单介绍下这几种源：</p>
<h4>3.2.1 NSPort 基于端口的源</h4>
<p>Cocoa和 Core Foundation 为使用端口相关的对象和函数创建的基于端口的源提供了内在支持。Cocoa中你从不需要直接创建输入源。你只需要简单的创建端口对象，并使用NSPort的方法将端口对象加入到run loop。端口对象会处理创建以及配置输入源。</p>
<p>NSPort一般分三种：&nbsp;<code>NSMessagePort</code>（基本废弃）、<code>NSMachPort</code>、&nbsp;<code>NSSocketPort</code>。 系统中的<code>NSURLConnection</code>就是基于<code>NSSocketPort</code>进行通信的，所以当在后台线程中使用<code>NSURLConnection</code>时，需要手动启动RunLoop, 因为后台线程中的RunLoop默认是没有启动的，后面会讲到。</p>
<h4>3.2.2 自定义输入源</h4>
<p>在Core Foundation程序中，必须使用CFRunLoopSourceRef类型相关的函数来创建自定义输入源，接着使用回调函数来配置输入源。Core Fundation会在恰当的时候调用回调函数，处理输入事件以及清理源。常见的触摸、滚动事件等就是该类源，由系统内部实现。</p>
<p>一般我们不会使用该种源，第三种情况已经满足我们的需求</p>
<h4>3.2.3 performSelector:OnThread</h4>
<p>Cocoa提供了可以在任一线程执行函数（perform selector）的输入源。和基于端口的源一样，perform selector请求会在目标线程上序列化，减缓许多在单个线程上容易引起的同步问题。而和基于端口的源不同的是，perform selector执行完后会自动清除出run loop。</p>
<p>此方法简单实用，使用也更广泛。</p>
<h4>3.2.4 定时源</h4>
<p>定时源就是NSTimer了，定时源在预设的时间点同步地传递消息。因为Timer是基于RunLoop的，也就决定了它不是实时的。</p>
<h3>3.3 RunLoop观察者</h3>
<p>我们可以通过创建<code>CFRunLoopObserverRef</code>对象来检测RunLoop的工作状态，它可以检测RunLoop的以下几种事件：</p>
<ul><li>Run loop入口</li>
<li>Run loop将要开始定时</li>
<li>Run loop将要处理输入源</li>
<li>Run loop将要休眠</li>
<li>Run loop被唤醒但又在执行唤醒事件前</li>
<li>Run loop终止</li></ul>
<h3>3.4 Run Loop Modes</h3>
<p>RunLoop对于上述四种事件源的监视，可以通过设置模式来决定监视哪些源。 RunLoop只会处理与当前模式相关联的源，未与当前模式关联的源则处于暂停状态。</p>
<p>cocoa和Core Foundation预先定义了一些模式（Apple文档翻译）：</p>
<table>
<tbody>
<tr>
<th>Mode</th>
<th>Name</th>
<th>Description</th>
</tr>
<tr>
<td>Default</td>
<td>NSDefaultRunLoopMode (Cocoa) kCFRunLoopDefaultMode (Core Foundation)</td>
<td>缺省情况下，将包含所有操作，并且大多数情况下都会使用此模式</td>
</tr>
<tr>
<td>Connection</td>
<td>NSConnectionReplyMode (Cocoa)</td>
<td>此模式用于处理NSConnection的回调事件</td>
</tr>
<tr>
<td>Modal</td>
<td>NSModalPanelRunLoopMode (Cocoa)</td>
<td>模态模式，此模式下，RunLoop只对处理模态相关事件</td>
</tr>
<tr>
<td>Event Tracking</td>
<td>NSEventTrackingRunLoopMode (Cocoa)</td>
<td>此模式下用于处理窗口事件,鼠标事件等</td>
</tr>
<tr>
<td>Common Modes</td>
<td>NSRunLoopCommonModes (Cocoa) kCFRunLoopCommonModes (Core Foundation)</td>
<td>此模式用于配置&rdquo;组模式&rdquo;，一个输入源与此模式关联，则输入源与组中的所有模式相关联。</td>
</tr>
</tbody>
</table>
<p>我们也可以自定义模式，可以参考<code>ASIHttpRequest</code>在同步执行时，自定义了 runLoop 的模式叫<code>ASIHTTPRequestRunLoopMode</code>。ASI的Timer源就关联了此模式。</p>
<h3>3.5 常见问题一：为什么TableView滑动时，Timer暂停了？</h3>
<p>我们做个测试： 在一个 viewController 的&nbsp;<code>scrollViewWillBeginDecelerating:</code>&nbsp;方法里面打个断点， 然后滑动&nbsp;<code>tableView</code>。 待断点处， 使用&nbsp;<code>lldb</code>&nbsp;打印一下&nbsp;<code>[NSRunLoop currentRunLoop]</code>&nbsp;。 在描述中可以看到当前的RunLoop的运行模式：</p>
<pre class="prettyprint linenums"><code>current mode = UITrackingRunLoopMode<br />
common modes = &lt;CFBasicHash 0x14656e60 [0x3944dae0]&gt;{type = mutable set, count = 2,<br />
entries =&gt;<br />
0 : &lt;CFString 0x398d54c0 [0x3944dae0]&gt;{contents = "UITrackingRunLoopMode"}<br />
1 : &lt;CFString 0x39449d10 [0x3944dae0]&gt;{contents = "kCFRunLoopDefaultMode"}<br />
}<br />
</code></pre>
<p>也就是说，当前主线程的 RunLoop 正在以&nbsp;<code>UITrackingRunLoopMode</code>&nbsp;的模式运行。 这个时候 RunLoop 只会处理与&nbsp;<code>UITrackingRunLoopMode</code>&nbsp;&ldquo;绑定&rdquo;的源， 比如触摸、滚动等事件；而&nbsp;<code>NSTimer</code>&nbsp;是默认&ldquo;绑定&rdquo;到&nbsp;<code>NSRunLoopDefaultMode</code>&nbsp;上的， 所以&nbsp;<code>Timer</code>&nbsp;是事情是不会被 RunLoop 处理的，我们的看到的时定时器被暂停了！</p>
<p>常见的解决方案是把Timer&ldquo;绑定&rdquo;到&nbsp;<code>NSRunLoopCommonModes</code>&nbsp;模式上， 那么Timer就可以与：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>[[NSRunLoop currentRunLoop] addTimer:timer forMode:NSRunLoopCommonModes];<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>这样这个Timer就可以和当前组中的两种模式&nbsp;<code>UITrackingRunLoopMode</code>&nbsp;和&nbsp;<code>kCFRunLoopDefaultMode</code>&nbsp;相关联了。 RunLoop在这两种模式下，Timer都可以正常运行了。</p>
<p>注意： 由上面可以发现&nbsp;<code>NSTimer</code>&nbsp;是不准确的。 因为RunLoop只负责分发源的消息。如果线程当前正在处理繁重的任务，比如循环，就有可能导致Timer本次延时，或者少执行一次。网上有人做过实验：</p>
<p><img referrerpolicy="no-referrer"src="https://blog.cnbluebox.com/images/runloop_timer.jpeg" /></p>
<p>上面的Log是一个间隔为&nbsp;<code>1 s</code>&nbsp;的计时器，我们可以发现在&nbsp;<code>12.836s ~ 15.835s</code>&nbsp;之间的时间段内， 明显的&nbsp;<code>13s</code>&nbsp;的方法没有执行。&nbsp;<code>14s</code>&nbsp;的方法有所延迟。</p>
<p>因此当我们用NSTimer来完成一些计时任务时，如果需要比较精确的话，最好还是要比较&ldquo;时间戳&rdquo;。</p>
<h3>3.6 常见问题二：后台的NSURLConnection不回调，Timer不运行</h3>
<p>我们知道每个线程都有它的RunLoop, 我们可以通过&nbsp;<code>[NSRunLoop currentRunLoop]</code>&nbsp;或<code>CFRunLoopGetCurrent()</code>&nbsp;来获取。 但是主线程和后台线程是不一样的。主线程的RunLoop是一直在启动的。而后台线程的RunLoop是默认没有启动的。</p>
<p>后台线程的RunLoop没有启动的情况下的现象就是：&ldquo;代码执行完，线程就结束被回收了&rdquo;。就像我们简单的程序执行完就退出了。 所以如果我们希望在代码执行完成后还要保留线程等待一些异步的事件时，比如NSURLConnection和NSTimer， 就需要手动启动后台线程的RunLoop。</p>
<p>启动RunLoop，我们需要设定RunLoop的模式，我们可以设置&nbsp;<code>NSDefaultRunLoopMode</code>。 那默认就是监听所有时间源：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>//Cocoa<br />
[[NSRunLoop currentRunLoop] runMode:NSDefaultRunLoopMode beforeDate:[NSDate distantFuture]];

//Core Foundation<br />
CFRunLoopRun();<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>我们也可以设置其他模式运行, 甚至自定义运行Mode，但是我们就需要把&ldquo;事件源&rdquo; &ldquo;绑定&rdquo;到该模式上：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>extern NSString *kMyCustomRunLoopMode;<br />
//NSURLConnection<br />
[_connection scheduleInRunLoop:[NSRunLoop currentRunLoop] forMode:kMyCustomRunLoopMode];<br />
[[NSRunLoop currentRunLoop] runMode:kMyCustomRunLoopMode beforeDate:[NSDate distantFuture]];

//Timer<br />
[[NSRunLoop currentRunLoop] addTimer:_timer forMode:kMyCustomRunLoopMode];<br />
[[NSRunLoop currentRunLoop] runMode:kMyCustomRunLoopMode beforeDate:[NSDate distantFuture]];<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<h3>3.7 NSCommonRunLoopModes</h3>
<blockquote><p>这一节是2016-3-24补充</p></blockquote>
<p>因为以前的3.6的代码有个错误，而且对于<code>NSRunLoopCommonModes</code>没有详细说明，造成有同学对这块产生困惑, 因此有必要再开一节补充下关于<code>NSRunLoopCommonModes</code>的概念。</p>
<p><code>NSRunLoopCommonModes</code>&nbsp;并不是一个真正的runLoopMode, 也就是说这样的写法是错误的：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>[[NSRunLoop currentRunLoop] runMode:NSRunLoopCommonModes beforeDate:[NSDate distantFuture]]; //wrong<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>这个写法并不会让runLoop运行。</p>
<p>下面解释下什么是CommonModes。</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>struct __CFRunLoop {<br />
    CFMutableSetRef _commonModes;     // 有哪些Mode被标记为Common<br />
    CFMutableSetRef _commonModeItems; // 这里面就是RunLoop的源，observer,Timer等<br />
    CFRunLoopModeRef _currentMode;    // 当前运行的Mode<br />
    ...<br />
};<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>上面大概是<code>CFRunLoop</code>中有关CommonMode的结构。这里面2个概念解释一下：</p>
<ul><li><p>在RunLoop里可以用<code>CFRunLoopAddCommonMode</code>将一个Mode标记为<code>Common</code>属性，那么这个Mode就会存在<code>_commonModes</code>里面。主线程默认的<code>kCFRunLoopDefaultMode</code>&nbsp;和&nbsp;<code>UITrackingRunLoopMode</code>&nbsp;都已经是<code>CommonModes</code>了，不需要再标记。</p></li>
<li><p><code>_commonModeItems</code>里面存放的源, observer, timer等，在每次runLoop运行的时候都会被同步到具有<code>Common</code>标记的Modes里。因此只要<code>_currentMode</code>是一个<code>Common</code>的Mode, 那么<code>_commonModeItems</code>里面的源,observer,timer也会执行。</p></li></ul>
<p>因此这样addTimer时，timer也会执行的, 因为timer被添加到了<code>_commonModeItems</code>里面。</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>[[NSRunLoop currentRunLoop] addTimer:_timer forMode:NSRunLoopCommonModes];<br />
[[NSRunLoop currentRunLoop] runMode:NSRunLoopDefaultMode beforeDate:[NSDate distantFuture]];<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<h3>3.8 问题三：本节开头的例子为何可以阻塞线程</h3>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>while (!complete) {<br />
  [[NSRunLoop currentRunLoop] runMode:NSDefaultRunLoopMode beforeDate:[NSDate distantFuture]];<br />
}<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>你应该知道这样一段代码可以阻塞当前线程，你可能会奇怪：RunLoop就是不停循环来检测源的事件，为什么还要加个&nbsp;<code>while</code>&nbsp;呢？</p>
<p>这是因为RunLoop的特性，RunLoop会在没有&ldquo;事件源&rdquo;可监听时休眠。也就是说如果当前没有合适的&ldquo;源&rdquo;被RunLoop监听，那么这步就跳过了，不能起到阻塞线程的作用，所以还是要加个while循环来维持。</p>
<p>同时注意：因为这段代码可以阻塞线程，所以请不要在主线程写下这段代码，因为它很可能会导致界面卡住。</p>
<h2>4. 线程安全</h2>
<p>讲了这么多，你是否已经对并发编程已经跃跃欲试了呢？ 但是并发编程一直都不是一个轻松的事情，使用并发编程会带来许多陷阱。哪怕你是一个很成熟的程序员和架构师，也很难避免线程安全的问题；使用的越多，出错的可能就越大，因此可以不用多线程就不要使用。</p>
<p>关于并发编程的不可预见性有一个非常有名的例子：在1995年， NASA (美国宇航局)发送了开拓者号火星探测器，但是当探测器成功着陆在我们红色的邻居星球后不久，任务嘎然而止，火星探测器莫名其妙的不停重启，在计算机领域内，遇到的这种现象被定为为优先级反转，也就是说低优先级的线程一直阻塞着高优先级的线程。在这里我们想说明的是，即使拥有丰富的资源和大量优秀工程师的智慧，并发也还是会在不少情况下反咬你你一口。</p>
<h3>4.1 资源共享和资源饥饿</h3>
<p>并发编程中许多问题的根源就是在多线程中访问共享资源。资源可以是一个属性、一个对象，通用的内存、网络设备或者一个文件等等。在多线程中任何一个共享的资源都可能是一个潜在的冲突点，你必须精心设计以防止这种冲突的发生。</p>
<p>一般我们通过锁来解决资源共享的问题，也就是可以通过对资源加锁保证同时只有一个线程访问资源</p>
<h4>4.1.1 互斥锁</h4>
<p>互斥访问的意思就是同一时刻，只允许一个线程访问某个特定资源。为了保证这一点，每个希望访问共享资源的线程，首先需要获得一个共享资源的互斥锁。 对资源加锁会引发一定的性能代价。</p>
<h4>4.1.2 原子性</h4>
<p>从语言层面来说，在 Objective-C 中将属性以 atomic 的形式来声明，就能支持互斥锁了。事实上在默认情况下，属性就是 atomic 的。将一个属性声明为 atomic 表示每次访问该属性都会进行隐式的加锁和解锁操作。虽然最把稳的做法就是将所有的属性都声明为 atomic，但是加解锁这也会付出一定的代价。</p>
<h4>4.1.3 死锁</h4>
<p>互斥锁解决了竞态条件的问题，但很不幸同时这也引入了一些其他问题，其中一个就是死锁。当多个线程在相互等待着对方的结束时，就会发生死锁，这时程序可能会被卡住。</p>
<p>比如下面的代码：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>dispatch_sync(_queue, ^{<br />
  dispatch_sync(_queue, ^{<br />
      //do something<br />
  });<br />
})<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>再比如：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5
</pre>
</td>
<td>
<pre class="prettyprint linenums"><code>main() {<br />
dispatch_sync(dispatch_get_main_queue(), ^{<br />
  //do something<br />
});<br />
}<br />
</code></pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>上面两个例子也可以说明&nbsp;<code>dispatch_sync</code>&nbsp;这个API是危险的，所以尽量不要用。</p>
<p><strong>当你的代码有死锁的可能时，它就会发生</strong></p>
<h4>4.1.4 资源饥饿</h4>
<p>当你认为已经足够了解并发编程面临的问题时，又出现了一个新的问题。锁定的共享资源会引起读写问题。大多数情况下，限制资源一次只能有一个线程进行读取访问其实是非常浪费的。因此，在资源上没有写入锁的时候，持有一个读取锁是被允许的。这种情况下，如果一个持有读取锁的线程在等待获取写入锁的时候，其他希望读取资源的线程则因为无法获得这个读取锁而导致资源饥饿的发生。</p>
<h3>4.2 优先级反转</h3>
<p>优先级反转是指程序在运行时低优先级的任务阻塞了高优先级的任务，有效的反转了任务的优先级。GCD提供了3种级别的优先级队列，分别是Default, High, Low。 高优先级和低优先级的任务之间共享资源时，就可能发生优先级反转。当低优先级的任务获得了共享资源的锁时，该任务应该迅速完成，并释放掉锁，这样高优先级的任务就可以在没有明显延时的情况下继续执行。然而高优先级任务会在低优先级的任务持有锁的期间被阻塞。如果这时候有一个中优先级的任务(该任务不需要那个共享资源)，那么它就有可能会抢占低优先级任务而被执行，因为此时高优先级任务是被阻塞的，所以中优先级任务是目前所有可运行任务中优先级最高的。此时，中优先级任务就会阻塞着低优先级任务，导致低优先级任务不能释放掉锁，这也就会引起高优先级任务一直在等待锁的释放。如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://blog.cnbluebox.com/images/priority-inversion.png" /></p>
<p>使用不同优先级的多个队列听起来虽然不错，但毕竟是纸上谈兵。它将让本来就复杂的并行编程变得更加复杂和不可预见。因此我们写代码的时候最好只用Default优先级的队列，不要使用其他队列来让问题复杂化。</p>
<p>关于dispatch_queue的底层线程安全设计可参考：<a href="http://webfrogs.me/2013/07/18/low-level_concurrency_apis/" rel="external nofollow noreferrer">底层并发 API</a></p>
<h2>5. 总结</h2>
<p>本文主要讲了 NSOperationQueue、 NSRunLoop、 和线程安全等三大块内容。 希望可以帮助你理解 NSOperation的使用， NSRunLoop的作用， 还有并发编程带来的复杂性和相关问题。</p>
<p>并发实际上是一个非常棒的工具。它充分利用了现代多核 CPU 的强大计算能力。但是因为它的复杂性，所以我们尽量使用高级的API，尽量写简单的代码，让并发模型保持简单； 这样可以写出高效、结构清晰、且安全的代码。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93xlmg9.html">【转】OpenGL多线程创建纹理，附加我的测试结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdn7gj9.html">org&period;springframework&period;orm&period;hibernate3&period;LocalSessionFactoryBean的疑惑解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdg2de8.html">spark与storm的对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1omz69.html">IIS报错 未将对象引用设置到对象的实例。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn441z8.html">cocos2d-x实战 C&plus;&plus;卷 学习笔记--第5章 精灵</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1x70x9.html">android 登陆案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1x2nd9.html">安装 Linux 与 Windows 10 双系统，你需要了解的一切</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1k5v28.html">多语言文本资源的访问&lpar;Windows&colon;ini&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y22l5q.html">SCU3502 The Almost Lucky Number</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg5k69.html">spring springMVC mybatis 集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mp1o1q.html">C&plus;&plus;学习笔记29，引用变量（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zg7x49.html">Spring集成log4j日志管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpn44j9.html">JavaScript定时机制、以及浏览器渲染机制 浅谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjo4o38.html">php 计算两点地理坐标的距离</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj02zj9.html">WIN10下Java环境变量配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2555lvq.html">&dollar;&lpar;document&rpar;&period;on&lpar;&amp;&num;39&semi;click&amp;&num;39&semi;&comma;&amp;&num;39&semi;&period;classname&amp;&num;39&semi;&comma;function&lpar;&rpar;&lbrace;&rcub;&rpar;&semi; VS &dollar;&lpar;&amp;&num;39&semi;&period;classname&amp;&num;39&semi;&rpar;&period;on&lpar;&amp;&num;39&semi;click&amp;&num;39&semi;&comma;function&lpar;&rpar;&lbrace;&rcub;&rpar;&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy46emq.html">Spring事物的属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdo7jz9.html">shell编程  之  输入输出重定向</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyg3zxq.html">U-boot2010&period;06移植--阶段一</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5k71rq.html">stark组件开发之列表页面应用示例</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/6o8ke78j.html">Tomcat shutdown执行后无法退出进程问题排查及解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7m7jqe.html">记一次SQLServer的分页优化兼谈谈使用Row&lowbar;Number&lpar;&rpar;分页存在的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wooq7.html">0&period;Win8&period;1，Win10，Windows Server 2012 安装 Net Framework 3&period;5</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2j2x87.html">Convert BSpline Curve to Arc Spline in OpenCASCADE</a>
			</li>
						<li><a href="https://www.batexi.com/a/4950e08z.html">ASP&period;NET MVC5&plus;EF6&plus;EasyUI 后台管理系统（67）-MVC与ECharts</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ge2l87.html">OVS 中的各种网络设备 - 每天5分钟玩转 OpenStack（128）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyyy2qr.html">javascript中的操作符详解1</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdww79d.html">9、 Struts2验证&lpar;声明式验证、自定义验证器&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93pow83.html">更愉快的书写CSS</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql1g09o.html">JDK动态代理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
